#!/bin/bash
export LD_LIBRARY_PATH=/home/carlos/desarrollo/masyro08/fipa/src/cpp
export HOSTNAME=kurt
export MAGARRO_HOME=/home/carlos/desarrollo/masyro08/fipa/src/app/magarro

### FIPA
cd /home/carlos/desarrollo/masyro08/fipa/config/
icegridnode --Ice.Config=config.icegrid --daemon --nochdir
echo "Deploying the node and the registry..."
echo ".........."
sleep 3
icegridadmin --Ice.Config=config.icegridadmin -e "application add appFIPA.xml"
echo "Starting the FIPA multiagent system..."
sleep 1
icegridadmin --Ice.Config=config.icegridadmin -e "server start FIPAServices"
echo "Starting the basic services..."
sleep 1
echo "Agent Management System started..."
echo "Directory Facilitator started..."
echo "Agent Communication Channel started..."
echo ".........."
sleep 1

### MAGARRO
cd ../src/app/magarro/
echo "Starting MAGARRO services... "
python Analyst.py analyst &
sleep 1
echo "Analyst started..."
python Master.py master &
sleep 1
echo "Master started..."
python Blackboard.py blackboard &
sleep 1
echo "Blackboard started..."
python ModelRepository.py modelRepository &
sleep 1
echo "ModelRepository started..."
echo ".........."
sleep 2

## RENDER AGENTS
echo "Starting render agents..."
for i in `seq 1 $1`;
do
  val='Agent_'$i
  python RenderAgent.py $val &
  echo "Starting " $val
done
