#!/usr/bin/python
# -*- coding: utf-8 -*-

import Blender
from Blender import *
from Blender.Scene import Render

class Render:

    def __init__ (self):
        self.RenderingContext = Scene.GetCurrent().getRenderingContext()

    def setRenderPath (self, renderPath):
        self.getRenderingContext().setRenderPath(renderPath)

    def getRenderingContext (self):
        return self.RenderingContext

    def setResX (self, resX):
        self.getRenderingContext().imageSizeX(resX)

    def getResX (self):
        return self.getRenderingContext().imageSizeX()

    def getResy (self):
        return self.getRenderingContext().imageSizeY()

    def setResY (self, resY):
        self.getRenderingContext().imageSizeY(resY)

    def setOversamplingLevel (self, level):

        self.getRenderingContext().enableOversampling(1)
        self.getRenderingContext().setOversamplingLevel(level)

    def setRenderBorder (self, left, bottom, right, top):

        self.getRenderingContext().enableBorderRender(1)
        self.getRenderingContext().setBorder(left, bottom, right, top)

    def setGeneralSettings (self):

        self.getRenderingContext().setImageType(Render.PNG)
