#!/usr/bin/python
# -*- coding: utf-8 -*-

import os, sys

HOST = os.environ['HOSTNAME']
LOCAL_HOSTS = ['exeter66', 'kurt']
MAGARRO_HOME = os.environ['MAGARRO_HOME']

if HOST not in LOCAL_HOSTS:
        sys.path.append('/usr/local/IcePy-3.2.0/python')

import Ice

if HOST not in LOCAL_HOSTS:
	Ice.loadSlice('--all -I/usr/local/Ice-3.2.0/slice -I' + MAGARRO_HOME + '/../../../slice -I/usr/share/slice ' + MAGARRO_HOME + '/Magarro.ice')
else:
	Ice.loadSlice('--all -I../../../slice -I. -I/usr/share/slice Magarro.ice')
import FIPA
import Util, array, sys

class Boss (Ice.Application):

    def run (self, argv):

        self.shutdownOnInterrupt()

        try:
            obj = self.communicator().stringToProxy('master')
            prx = FIPA.MasterPrx.uncheckedCast(obj)
            prx.clean()
            prx.destroy()
        except Ice.NotRegisteredException:
            print 'The master is down.'
        except Ice.ObjectNotExistException:
            print 'One of the rendering agents does not exist.'
        except Ice.LocalException:
            print 'Ice exception when stopping the master.'

        try:
            obj = self.communicator().stringToProxy('blackboard')
            prx = FIPA.BlackboardPrx.uncheckedCast(obj)
            prx.destroy()
        except Ice.NotRegisteredException:
            print 'The blackboard is down.'
        except Ice.LocalException, er:
            print 'Ice exception when stopping the blackboard.'

        try:
            obj = self.communicator().stringToProxy('modelRepository')
            prx = FIPA.ModelRepositoryPrx.uncheckedCast(obj)
            prx.destroy()
        except Ice.NotRegisteredException:
            print 'The modelRepository is down.'
        except Ice.LocalException:
            print 'Ice exception when stopping the modelRepository.'

        try:
            obj = self.communicator().stringToProxy('analyst')
            prx = FIPA.AnalystPrx.uncheckedCast(obj)
            prx.destroy()
        except Ice.NotRegisteredException:
            print 'The analyst is down.'
        except Ice.LocalException:
            print 'Ice exception when stopping the analyst.'

	return 0

Boss().main(sys.argv, '../../../config/config.agent')
