#include <Ice/Ice.h>
#include <FIPA.h>
#include <AgentManagementSystemI.h>

class BasicServices : virtual public Ice::Application
{
  virtual int run (int,
		   char*[])
  {
    Ice::PropertiesPtr properties = communicator()->getProperties();
    Ice::ObjectAdapterPtr adapter = communicator()->createObjectAdapter("AgentManagementAdapter");
    Ice::Identity id = communicator()->stringToIdentity(properties->getProperty("Identity"));
    std::string description = "";
    adapter->add(new AgentManagementSystemI(description), id);
    adapter->activate();

    communicator()->waitForShutdown();
    
    return EXIT_SUCCESS;
  }
};

int
main(int argc,
     char* argv[])
{
  BasicServices services;
  return services.main(argc, argv);
}
