#include <CommunicativeActLibrary.h>

using namespace std;

static void
CommunicativeActLibrary::processMessage(const string& role,
					VStack& conv,
					const FIPA::ACLRepresentation rep,
					const FIPA::Payload p,
					const std::vector values)
{
  initialize();

  switch(s_mapStringValues[p.performative])
    {
    case request:
      request(role, conv, rep, p, values);
      break;
    case agree:
      //agree(role, conv, rep, p, values);
      break;
    case refuse:
      //refuse(role, conv, rep, p, values);
      break;
    case inform:
      //inform(role, conv, rep, p, values);
      break;
    case failure:
      //failure(role, conv, rep, p, values);
      break;
    }
}

static void
CommunicativeActLibrary::request(const string& role,
				 VStack& conv,
				 const FIPA::ACLRepresentation rep,
				 const FIPA::Payload p,
				 const bool value)
{
  for (SVector::iterator it = conv.top().begin();
       it != conv.top().end();
       ++it)
    {
      if (*it == m.content.performative)
	{
	  _conversations[m.content.conversationId].pop();
	  break;
	}
    }
}

void
CommunicativeActLibrary::initialize()
{
  s_mapStringValues["request"] = request;
  s_mapStringValues["agree"] = agree;
  s_mapStringValues["refuse"] = refuse;
  s_mapStringValues["inform"] = inform;
  s_mapStringValues["failure"] = failure;
  
  cout << "s_mapStringValues contains "
       << s_mapStringValues.size()
       << " entries." << endl;
}
