#include <DirectoryFacilitatorI.h>
#include <IceGrid/Admin.h>
#include <IceStorm/IceStorm.h>
#include <Ice/Ice.h>

using namespace std;
using namespace FIPA;
using namespace Ice;

Freeze::EvictorPtr DirectoryFacilitatorI::_evictor = NULL;

DirectoryFacilitatorI::DirectoryFacilitatorI():
  _agent(NULL)
{
}

void
DirectoryFacilitatorI::_cpp_register(const ::FIPA::DfAgentDescription& ad,
				     const ::Ice::Current& curr)
{
  IceUtil::Mutex::Lock lock(*this);

  agents.push_back(ad);
  cout << ad.proxy->ice_toString() << " registered." << endl;

  if (!_agent)
    {
      IceStorm::TopicPrx topic;
      topic = IceStorm::TopicPrx::
	uncheckedCast(curr.adapter->getCommunicator()->stringToProxy("DF/topic.DirectoryFacilitator"));
      assert(topic);

      Ice::ObjectPrx obj = topic->getPublisher();
      if (!obj->ice_isDatagram())
	{
	  obj->ice_oneway();
	}
      _agent = FIPA::AgentPrx::uncheckedCast(obj);
    }
  _agent->inform(ad.proxy, ad.desc.services);
  cout << "Agents registered: " << agents.size() << endl;
}

void
DirectoryFacilitatorI::deregister(const ::FIPA::AgentPrx& agentPrx,
				  const ::Ice::Current&)
{
  IceUtil::Mutex::Lock lock(*this);

  AgentDirectory::iterator it;
  for (it = agents.begin();
       it != agents.end();
       ++it)
    {
      if (proxyIdentityEqual(agentPrx, it->proxy))
	{
	  agents.erase(it);
	  cout << agentPrx->ice_toString() << " deregistered." << endl;
	  break;
	}
    }
}

Ice::ObjectPtr
DirectoryFacilitatorFactory::create(const std::string& type)
{
  return new DirectoryFacilitatorI();
}

void
DirectoryFacilitatorFactory::destroy()
{
}

void
DirectoryFacilitatorInitializer::initialize(const Ice::ObjectAdapterPtr& oa, 
			     const Ice::Identity& ident, 
			     const std::string& str, 
			     const Ice::ObjectPtr& obj)
{
  DirectoryFacilitatorIPtr ptr = DirectoryFacilitatorIPtr::dynamicCast(obj);
}
