#ifndef DirectoryFacilitatorI_H
#define DirectoryFacilitatorI_H

#include <FIPA.h>
#include <Freeze/Freeze.h>
#include <IceUtil/IceUtil.h>

class DirectoryFacilitatorI: public FIPA::DirectoryFacilitatorPersistent,
			     public IceUtil::AbstractMutexI<IceUtil::Mutex>
{
  friend class DirectoryFacilitatorInitializer;
 public:
  
  DirectoryFacilitatorI();

  virtual void _cpp_register(const ::FIPA::DfAgentDescription&,
			     const ::Ice::Current&);
  virtual void deregister(const ::FIPA::AgentPrx&, const ::Ice::Current&);

  static Freeze::EvictorPtr _evictor;

 private:

  FIPA::AgentPrx _agent;
};

typedef IceUtil::Handle<DirectoryFacilitatorI> DirectoryFacilitatorIPtr;

class DirectoryFacilitatorFactory: public Ice::ObjectFactory
{
 public:
  
  virtual Ice::ObjectPtr create(const std::string& type);
  virtual void destroy();
};

class DirectoryFacilitatorInitializer: public Freeze::ServantInitializer
{
 public:

  virtual void initialize(const Ice::ObjectAdapterPtr& oa, 
			  const Ice::Identity& ident, 
			  const std::string& str, 
			  const Ice::ObjectPtr& obj);
};

#endif
