#include <Ice/Application.h>
#include <IceGrid/Admin.h>
#include <Video.h>
#include <VideoAgentI.h>

using namespace std;

class VideoAgent : virtual public Ice::Application {
  virtual int run (int argc,
		   char* argv[])
  {

    Ice::ObjectAdapterPtr adapter = 
      communicator()->createObjectAdapter("AgentAdapter");
    Video::VideoAgentPrx videoAgent = Video::VideoAgentPrx::checkedCast(adapter->addWithUUID(new VideoAgentI));
    adapter->activate();
    Ice::ObjectPrx proxy = communicator()->stringToProxy("FIPA/Admin");
    IceGrid::AdminPrx admin = IceGrid::AdminPrx::checkedCast(proxy);

    try
      {
	admin->addObjectWithType(videoAgent, videoAgent->ice_id());
      }
    catch (const IceGrid::ObjectExistsException&)
      {
	admin->updateObject(videoAgent);
      }

    communicator()->waitForShutdown();
    videoAgent->destroy();

    return 0;

  }
};

int main (int argc,
	  char *argv[])
{
  VideoAgent videoAgent;
  return videoAgent.main(argc, argv, "../../config/config.agent");
}
