import sys
sys.path.append('/usr/local/IcePy-3.2.0/python')
import Ice, IceGrid, IceStorm
Ice.loadSlice('../../slice/FIPA.ice', ['-I' '/usr/share/slice' '/usr/local/Ice-3.2.0/slice'])
import FIPA
import AgentI
from AgentI import *

class Agent(Ice.Application):

    def run(self, args):
        self.shutdownOnInterrupt()
        
        adapter = self.communicator().createObjectAdapter("AgentAdapter")
        adapter.activate()
        
        id = self.communicator().stringToIdentity(Ice.generateUUID())
        agentI = AgentI(None)
        proxy = adapter.add(agentI, id)
        agentPrx = FIPA.AgentPrx.uncheckedCast(proxy)
        print 'I am ' + agentPrx.ice_toString()

        prx = self.communicator().stringToProxy('FIPA/Registry')
        registryPrx = IceGrid.RegistryPrx.checkedCast(prx)

        try:
            adminSessionPrx = registryPrx.createAdminSession('david', 'dummy')
            adminPrx = adminSessionPrx.getAdmin()
        except IceGrid.PermissionDeniedException:
            print 'Permission denied.'
        except IceUtil.NullHandleException:
            print 'NullHandleException.'

        try:
            adminPrx.addObjectWithType(agentPrx, agentPrx.ice_id())
        except IceGrid.ObjectExistsException:
            print agentPrx.ice_toString() + 'exists.'

        prx2 = self.communicator().stringToProxy('FIPA/Query')
        queryPrx = IceGrid.QueryPrx.checkedCast(prx2)
        obj2 = queryPrx.findObjectById(self.communicator().
                                       stringToIdentity('DF/topic.DirectoryFacilitator'))
        topic = IceStorm.TopicPrx.uncheckedCast(obj2)
        
        try:
            topic.subscribeAndGetPublisher(None, proxy)
        except IceStorm.NoSuchTopic:
            print 'The topic does not exist.'

        obj3 = queryPrx.findObjectById(self.communicator().stringToIdentity('acc'))
        accPrx = FIPA.AgentCommunicationChannelPrx.uncheckedCast(obj3)
        print accPrx.ice_toString()
        m = FIPA.Message()
        m.content.protocol = 'fipa-request'
	m.content.performative = 'request'
	m.content.content = 'request'
	m.content.conversationId = 5694908;
        if len(args) >= 2:
            p = FIPA.AgentPrx.uncheckedCast(self.communicator().stringToProxy(sys.argv[1]))
            m.content.sender = agentPrx
            m.content.receiver = p
            m.transportInfo.to = []
	    m.transportInfo.to.append(p)
	    m.transportInfo.xfrom = agentPrx
	    m.transportInfo.rep = FIPA.ACLRepresentation.stringRep
            print 'Trying to send a message.'
	    agentI.sendMessage(m, accPrx);

        obj4 = queryPrx.findObjectById(self.communicator().stringToIdentity('df'))
        dfPrx = FIPA.DirectoryFacilitatorPrx.uncheckedCast(obj4)
        if dfPrx:
            description = FIPA.DfAgentDescription()
            description.proxy = agentPrx
            agentDesc = FIPA.AgentDescription()
            agentDesc.leaseTime = 0
            s = []
            s.append(FIPA.ServiceDescription('test', 'test'))            
            agentDesc.services = s
            description.desc = agentDesc
            dfPrx.register(description)
            dfPrx.deregister(agentPrx)

        #topic.unsubscribe(proxy)
        #agentPrx.destroy()

        self.communicator().waitForShutdown()

        return 0

Agent().main(sys.argv, '../../config/config.agent')
