#!/usr/bin/python
# -*- coding: utf-8 -*-

class Protocol:

    def __init__ (self):

        self.__name = 'fipa-request'
        self.__states = ['initial', 'requestes', 'refused', 'agreed', 'finished', 'cancelled']
        self.__inputs = ['request', 'refuse', 'agree', 'failure', 'inform', 'cancel']
        self.__outputs = ['sendMessage', 'finishConv', 'checkRequest', 'processRequest']

        self.__transitions = {}
        self.__transitions[('initial', 'request')] = 'requested'
        self.__transitions[('requested', 'agree')] = 'agreed'
        self.__transitions[('requested', 'refuse')] = 'refused'
        self.__transitions[('requested', 'cancel')] = 'cancelled'
        self.__transitions[('agreed', 'failure')] = 'refused'
        self.__transitions[('agreed', 'inform')] = 'finished'
        self.__transitions[('agreed', 'cancel')] = 'cancelled'
        self.__transitions[('cancelled', 'failure')] = 'refused'
        self.__transitions[('cancelled', 'inform')] = 'finished'

        self.__actions = {}
        self.__actions['requested'] = ['checkRequest']
        self.__actions['refused'] = ['sendMessage', 'finishConv']
        self.__actions['agreed'] = ['sendMessage', 'processRequest']
        self.__actions['finished'] = ['sendMessage', 'finishConv']

        self.__initial = 'initial'

    def transit (self, state, input):
        if self.__transitions.has_key((state, input)):
            return self.__transitions[(state, input)]
        else:
            return None
